/* ------------------------------------------------------------------------- */
/* ----- Let 'em Fly! Structure -------------------------------------------- */
/* ------------------------------------------------------------------------- */

#define C_LIGHT		0x8000	/* light version	*/
#define C_NICELN	0x4000	/* nicelines		*/
#define C_JUMP		0x2000	/* jumpin' dials	*/
#define C_FLYSWI	0x1000	/* conf. flymode switch	*/
#define C_VSCR		0x0800	/* VSCR support		*/
#define C_CENTER	0x0400	/* save position	*/
#define C_KEYS		0x0200	/* key dials		*/
#define C_EDIT		0x0100	/* extended editor	*/
#define C_REDRAW	0x0080	/* send redraw		*/
#define C_FLYTYP	0x0040	/* solid/hollow flights	*/
#define C_FLY		0x0020	/* flying ON/OFF	*/
#define C_ALERT		0x0010	/* alert-/error-boxes	*/
#define C_MOUSE		0x0008	/* dialogs to mouse	*/
#define C_F_GROW	0x0004	/* grow-/shrink-boxes	*/
#define C_G_GROW	0x0002	/* dto.			*/
#define C_BYPASS	0x0001	/* LTMF ON/OFF		*/

/* ------------------------------------------------------------------------- */

typedef struct
{
	unsigned int	version;
	unsigned int	conf;
	unsigned int	conf2;
	int	reserved;
	void	cdecl	(*di_fly)(OBJECT *tree);	/* fly routine		*/
	void	cdecl	(*obj_clsize)(OBJECT *tree, int obj, int *x, int *y, int *w, int *h);
	int	cdecl	(*do_key)(int key, int kshift);	/* User Keys	*/
	int	cdecl	(*init_keys)(OBJECT *tree);
	int	cdecl	(*lookup_key)(int key, int kshift);
	int	cdecl	(*di_moveto)(OBJECT *tree, int mx, int my);
	int	cdecl	(*di_center)(OBJECT *tree);
	int	ucol;	/* underscore color	*/
	int	aicol;	/* alert icon color	*/
	int	aframe;	/* alert frame size	*/
	int	flydelay;	/* delay before flying (form_do()-only)	*/
	int	cdecl	(*hist_insert)(char *string);
	char	cdecl	(*ins_spcchar)(void);
	void	cdecl	(*init_niceline)(OBJECT *tree);
} LTMFLY;
